# Generic makefile for BSD Make
# Copyright (c) 2002 ForestNet IRC Network
# $Id: Makedefs.mk,v 1.6 2002/11/19 22:58:12 hex Exp $

.include "Makevars"

CFLAGS=-pipe
LFLAGS=-o $(PROG)

.ifndef RM
RM=rm -f
.endif

.ifndef CC
CC=gcc
.endif

.ifndef MAKE
MAKE=make
.endif

.ifdef DEBUG
CFLAGS += -O0 -g -DDEBUGMODE
.else
CFLAGS += -O2 -fomit-frame-pointer
.endif

.ifdef INCDIR
CFLAGS += $(INCDIR:%=-I%)
.endif

.ifdef LIBDIR
LFLAGS += $(LIBDIR:%=-L%)
.endif

.ifdef NEED
CFLAGS += $(NEED:%=-DNEED_%)
.endif

.ifdef HAVE
CFLAGS += $(HAVE:%=-DHAVE_%)
.endif

.ifdef DEFS
CFLAGS += $(DEFS:%=-D%)
.endif

all: $(OBJS)
.ifdef PROG
	$(CC) $(LFLAGS) $(OBJS) $(ARCH) $(LIBS:%=-l%)
	@ls -ld $(PROG)
.else ifdef LIB
	ar -q $(LIB) $(OBJS)
	@ls -ld $(LIB)
.endif

debug:
	$(MAKE) -f Makefile -DDEBUG

clean:
	$(RM) $(OBJS)

cleandir:
.ifdef PROG
	$(RM) $(PROG) $(OBJS) *.core
.else ifdef LIB
	$(RM) $(LIB) $(OBJS)
.endif

strip:
.ifdef PROG
	-@if [ -x $(PROG) ]; then strip $(PROG); ls -ld $(PROG); fi
.endif

.SUFFIXES: .o .c

.c.o:
	$(CC) $(CFLAGS) -c $<
