/* ircdlog.c -- logging routines for faerion;
 * Copyright (C) 2001-2002 ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: ircdlog.c,v 1.6 2002/11/18 12:44:07 hex Exp $
 */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>

#include "struct.h" /* argh, we need BOOT_STDERR */
#include "h.h" /* for my_timestamp() */
#include "ircdlog.h"

int log_verbosity = LOG_WARNING;

void putlog(int priority, const char *message, ...)
{
	extern int bootopt;

	if (priority <= log_verbosity) {
		va_list vl;
		va_start(vl, message);

		if (bootopt & BOOT_STDERR) {
			fprintf(stderr, "%s ", my_timestamp());
			vfprintf(stderr, message, vl);
			fprintf(stderr, "\n");
		}
		else vsyslog(priority, message, vl);

		va_end(vl);
	}
}
