/* m_die.c -- server shutdown
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_die.c,v 1.7 2002/11/18 12:44:08 hex Exp $
 */

#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"

int m_die(aClient *cptr, aClient *sptr, int  parc, char *parv[])
{
	char *pass, tmpbuf[BUFSIZE + 1];

	if (check_registered(sptr) || !MyClient(sptr))
		return 0;

	if (!OPIsAdmin(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if ((pass = find_diepass())) {
		if (parc < 2) {
			sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
				me.name, parv[0], "DIE");
			return 0;
		}

		if (strcmp(pass, parv[1])) {
			sendto_one(sptr, err_str(ERR_PASSWDMISMATCH),
				me.name, parv[0]);
			return 0;
		}
	}

	sprintf(tmpbuf, "requested by %s", sptr->name);
	server_terminate(tmpbuf);

	return 0;
}
