/* m_links.c -- display the network structure
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_links.c,v 1.7 2002/11/18 12:44:08 hex Exp $
 */

#include "config.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "channel.h" /* for IsULine() */
#include "common.h" /* for server_mask and contact_url */

/* sender LINKS [target] mask */
int m_links(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	char *mask;
	aClient *acptr;

	if (check_registered_user(sptr))
		return 0;

	if (server_mask && !OPIsOper(sptr)) {
		sendto_one(sptr, ":%s NOTICE %s :/LINKS has been disabled, "
			"please visit %s for the list of servers.",
			me.name, sptr->name,
			contact_url ? contact_url : "the website");
		return 0;
	}

	if (parc > 2) {
		if (hunt_server(cptr, sptr, ":%s LINKS %s :%s", 1, parc, parv)
			!= HUNTED_ISME) return 0;
		mask = parv[2];
	}
	else mask = parc < 2 ? NULL : parv[1];

	collapse(mask);

	for (acptr = client; acptr; acptr = acptr->next) {
		if (!IsServer(acptr) && !IsMe(acptr))
			continue;
		if (!BadPtr(mask) && match(mask, acptr->name))
			continue;

		if (!IsULine(acptr,acptr) || IsAnOper(sptr))
			sendto_one(sptr, rpl_str(RPL_LINKS),
				me.name, parv[0], acptr->name,
				acptr->serv->up,
				acptr->hopcount,
				(acptr->info[0] ? acptr->info :
				"(Unknown Location)"));
	}

	sendto_one(sptr, rpl_str(RPL_ENDOFLINKS), me.name, parv[0],
		BadPtr(mask) ? "*" : mask);
	return 0;
}
