/* m_motd.c -- display message of the day;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_motd.c,v 1.9 2002/11/18 12:44:08 hex Exp $
 */

#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#ifdef _WIN32
# include <io.h>
#endif

#include "config.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "common.h"

int m_motd(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	int fd, nr;
	char line[80], *tmp;
	struct stat sb;
	struct tm *tm;

	if (check_registered(sptr))
		return 0;

	if (!BadPtr(server_mask) && parc > 1 && MyClient(sptr)
	&& !OPIsOper(sptr) && !strchr(parv[1], '.')) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (hunt_server(cptr, sptr, ":%s MOTD :%s", 1, parc, parv)
		!= HUNTED_ISME) return 0;

	if ((fd = open(MOTD, O_RDONLY)) == -1) {
		sendto_one(sptr, err_str(ERR_NOMOTD), me.name, parv[0]);
		return 0;
	}

	fstat(fd, &sb);

	sendto_one(sptr, rpl_str(RPL_MOTDSTART), me.name, parv[0], me.name);
	tm = localtime(&sb.st_mtime);
	sendto_one(sptr, ":%s %d %s :- %d/%d/%d %d:%02d", me.name,
		RPL_MOTD, parv[0], tm->tm_mday, tm->tm_mon + 1,
		1900 + tm->tm_year, tm->tm_hour, tm->tm_min);

	dgets(-1, NULL, 0); /* make sure buffer is at empty pos */

	while ((nr = dgets(fd, line, sizeof(line)-1)) > 0) {
		line[nr]='\0';
		if ((tmp = (char *)strchr(line,'\n')))
			*tmp = '\0';
		if ((tmp = (char *)strchr(line,'\r')))
			*tmp = '\0';
		sendto_one(sptr, rpl_str(RPL_MOTD), me.name, parv[0], line);
	}

	dgets(-1, NULL, 0); /* make sure buffer is at empty pos */
	sendto_one(sptr, rpl_str(RPL_ENDOFMOTD), me.name, parv[0]);
	close(fd);
	return 0;
}
