/* m_svsnick.c -- services change users' nicknames;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_svsnick.c,v 1.3 2002/11/18 12:44:08 hex Exp $
 */

#include "sys.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "channel.h" /* for IsULine(), argh */

/*
** m_svsnick
**     parv[0] = sender
**     parv[1] = old nickname
**     parv[2] = new nickname
**     parv[3] = timestamp
*/
int m_svsnick(aClient * cptr, aClient * sptr, int parc, char *parv[])
{
	aClient *acptr;
	time_t lastnick = (time_t) 0;

	if (!IsULine(cptr, sptr) || parc < 4 || (strlen(parv[2]) > NICKLEN))
		return 0;

	if (hunt_server(cptr, sptr, ":%s SVSNICK %s %s :%s", 1, parc, parv)
	!= HUNTED_ISME)
		return 0;

	if ((acptr = find_person(parv[1], NULL)) != NULL) {
		acptr->lastnick = atoi(parv[3]);
		sendto_common_channels(acptr, ":%s NICK :%s", parv[1], parv[2]);
		if (IsPerson(acptr))
			add_history(acptr);
		sendto_serv_butone(NULL, ":%s NICK %s :%i", parv[1], parv[2],
			atoi(parv[3]));
		if (acptr->name[0])
			del_from_client_hash_table(acptr->name, acptr);
		strcpy(acptr->name, parv[2]);
		add_to_client_hash_table(parv[2], acptr);

		if (acptr->umodes & UMODE_REGNICK) {
			acptr->umodes &= ~UMODE_REGNICK;
			sendto_one(acptr, ":%s MODE %s :-r", acptr->name,
				acptr->name);
		}
	}

	return 0;
}
